/*
	Autor        : Frank Link
	WEB          : www.derplatinenshop.de
	Datum        : 22.05.2008
	Ursprung     : http://www.roboternetz.de/wissen/index.php/Portexpander_am_AVR#Makros.2C_Datenstrukturen.2C_Funktionen
	Beschreibung : Bibliothek zur Ausgabe und Ansteuerung von 74HC595 ber einen ATMEL Mikrokontroller
				   ber Software SPI	
	CPU			 : ATMEGA 8
*/

#ifndef _COM74HC595_H_
#define _COM74HC595_H_

// Anzahl der ber SPI anzusteuernde 74HC595 Bausteine
#define COM74HC595_SIZE 1
// Anzahl der Bits ber alle Bausteine
#define COM74HC595_BYTES COM74HC595_SIZE * 8

// PORT am Mikrokontroller ber den der Software SPI erfolgen soll
#define PORT_COM74HC595 PORTB
#define PORT_SER 		PB0		//74HC595 PIN 14
#define PORT_SCK 		PB1		//74HC595 PIN 11
#define PORT_RCK 		PB2		//74HC595 PIN 12

#define DDR_COM74HC595  DDRB
#define DDR_SER 		DDB0	//74HC595 PIN 14
#define DDR_SCK 		DDB1	//74HC595 PIN 11
#define DDR_RCK 		DDB2	//74HC595 PIN 12

// globales Array zur Speicherung der Bitmuster
extern unsigned char com74hc595[];

// initialisierung der Ports im Mikrokontroller
extern void Com74hc595_init();

// Ausgabe der Bitmuster an die 74HC595
extern void Com74hc595_out();

// setzen eines einzelnen Bits innerhalb des Arrays
extern void Com74hc595_setBit( unsigned char BitNumber );

// zurcksetzen eines einzelnen Bits innerhalb des Arrays
extern void Com74hc595_unsetBit( unsigned char BitNumber );

// setzen eines ganzen Ports
extern void Com74hc595_setPort( unsigned char Port, unsigned char Bits );

// zurcksetzen eines ganzen Ports
extern void Com74hc595_unsetPort( unsigned char Port );

// setzt alle Bits auf logisch 1
extern void Com74hc595_setall();

// setzt alle Bits auf logisch 0
extern void Com74hc595_unsetall();

#endif /* _COM74HC595_H_ */
